﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WPattern.Example01.Interfaces;

namespace WPattern.Example01.Abstracts
{
    public class Abstract01 : IAbstract
    {
        #region Properties
        private INested NestedClass { get; set; }
        #endregion

        #region Constructors
        public Abstract01()
        {
            NestedClass = new Nested(this);
        }
        #endregion

        #region Private Methods
        private void PrivateMethod()
        {
            Console.WriteLine("Private method invoked in Abstract01.");
        }
        #endregion

        #region Nested Class
        private class Nested : INested
        {
            private Abstract01 AbstractObject01 { get; set; }

            public Nested(Abstract01 abstract01)
            {
                AbstractObject01 = abstract01;
            }

            public void NestedMethod()
            {
                AbstractObject01.PrivateMethod();
            }
        }
        #endregion
    }
}
