package br.com.wpattern.frameworks.jaxws.spring.server;

import javax.inject.Named;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;

import org.apache.log4j.Logger;

import br.com.wpattern.frameworks.jaxws.spring.server.interfaces.IMathService;

@Named
@WebService()
@SOAPBinding(style = SOAPBinding.Style.RPC, use = SOAPBinding.Use.LITERAL)
public class MathService implements IMathService {

	private Logger logger = Logger.getLogger(getClass());

	public MathService() {
		if (this.logger.isInfoEnabled()) {
			this.logger.info("Math service instance.");
		}
	}

	@Override
	@WebMethod(operationName = "hello")
	public String hello() {
		return "Hello SOAP!";
	}

	@Override
	@WebMethod(operationName = "sum")
	public int sum(@WebParam(name = "value1") int value1, @WebParam(name = "value2") int value2) {
		return value1 + value2;
	}

}
