using System;
using System.Collections.Generic;
using System.Text;

namespace AGs_em_Data_Mining
{
    public class Mundo
    {
        public static Random Rand = new Random();

        private List<Individuo> Populacao { get; set; }
        private Int32 TamanhoPopulacao { get; set; }
        private Int32 TaxaCrossover { get; set; }
        private Int32 TaxaMutacao { get; set; }
        private Int32 NumeroGeracoes { get; set; }
        private Int32 ContaGeracoes { get; set; }
        private Int32 NumeroGenes { get; set; }
        private Int32 Limiar { get; set; }
        private Int32 Classe { get; set; }
        private Int32 TipoEvolucao { get; set; }
        private Int32 MetodoSelecao { get; set; }

        #region Construtores
        public Mundo(Int32 tamanhoPopulacao, Int32 taxaCrossover, Int32 taxaMutacao, Int32 numeroGeracoes, Int32 numeroGenes, Int32 limiar, Int32 classe, Int32 tipoEvolucao, Int32 metodoSelecao)
        {
            this.TamanhoPopulacao = tamanhoPopulacao;
            this.TaxaCrossover    = taxaCrossover;
            this.TaxaMutacao      = taxaMutacao;
            this.NumeroGeracoes   = numeroGeracoes;
            this.NumeroGenes      = numeroGenes;
            this.Limiar           = limiar;
            this.Classe           = classe;
            this.TipoEvolucao     = tipoEvolucao;
            this.MetodoSelecao    = metodoSelecao;
        }
        #endregion

        #region Mtodos Pblicos
        public Individuo AGDataMining(List<Int32[]> baseDado)
        {
            ContaGeracoes = 0;
            Populacao = new List<Individuo>(TamanhoPopulacao);

            CriarPopulacao();

            CalculaAptidao(baseDado, 0, TamanhoPopulacao - 1);

            Populacao.Sort(new IndividuoComparer());

            while (++ContaGeracoes <= NumeroGeracoes)
            {
                Reproducao((Int32)(TamanhoPopulacao * (TaxaCrossover / 100.0f)));
                
                CalculaAptidao(baseDado, TamanhoPopulacao, Populacao.Count - 1);

                Evolucao();
            }

            return Populacao[Populacao.Count - 1];
        }

        public Individuo TestaMelhorIndividuo(List<Int32[]> baseDado, Individuo individuo)
        {
            // Deve ser calculada a aptido do individuo considerando o restante da base de testes (1/3 da base restante).
            return individuo;
        }
        #endregion

        #region Mtodos Privados
        private void CriarPopulacao()
        {
            // Devemos criar a populao inicial.
        }

        private void CalculaAptidao(List<Int32[]> baseDado, Int32 inicio, Int32 fim)
        {
            // Calcular a aptido dos indivduos comeando no ndice "inicio" at o ndice "fim".
            // Considerar os 2/3 iniciais da base de dados para calcular a aptido.
        }

        private void Reproducao(Int32 quantidadeIndividuos)
        {
            //  preciso realizar o processo de seleo, crossover e mutao.
            //  preciso considerar os tipos para cada operao.
        }

        private void Evolucao()
        {
            // Os piores indivduos so eliminados da populao.
        }
        #endregion
    }
}
